#include "EnumNamedCounterImpl.h"

#include <iostream>
using std::cout;
using std::endl;

#pragma warning(disable : 4786)  // identifier was truncated to '255' characters in the debug information

const size_t EnumNamedCounterEvictorTraits::maxServants = 10;
const size_t EnumNamedCounterEvictorTraits::timeout = 5;

EnumNamedCounterImpl::EnumNamedCounterImpl(
   NamedCounterFactoryImpl::CounterContainer &counters)
	:	RefCountedBase("EnumNamedCounterImpl"),
      m_counters(counters),
      m_current(counters.beginList())
{ 
	cout << "EnumNamedCounterImpl::EnumNamedCounterImpl() - " << this <<   endl; 
}

void EnumNamedCounterImpl::SetCurrent(NamedCounterFactoryImpl::CounterContainer::list_iterator &current) 
{
   m_current = current;
}

EnumNamedCounterImpl::~EnumNamedCounterImpl() 
{ 
	cout << "EnumNamedCounterImpl::~EnumNamedCounterImpl() - " << this << endl; 
}

CORBA::Long EnumNamedCounterImpl::Next(
   CORBA::ULong maxCounters, 
   counterSeq& theCounters)
{
	cout << "EnumNamedCounterImpl::Next() - " << maxCounters;

	long numCounters = 0;

   theCounters.length(maxCounters);

   while (m_current != m_counters.endList() && 
          numCounters < maxCounters)
   {
      (*m_current)->AddRef();
      theCounters[numCounters] = NamedCounter::_duplicate((*m_current)->_this());
	   ++m_current;
      ++numCounters;
   }

   theCounters.length(numCounters);

   cout << " - " << numCounters << endl;

   return numCounters;
}

CORBA::Boolean EnumNamedCounterImpl::Skip(CORBA::ULong numToSkip)
{
	cout << "EnumNamedCounterImpl::Skip() - " << numToSkip << endl;

	CORBA::ULong numSkipped = 0;

   while (m_current != m_counters.endList() && 
          numSkipped != numToSkip)
   {
      ++m_current;
      ++numSkipped;
   }

   return (numSkipped == numToSkip);
}

void EnumNamedCounterImpl::Reset()
{
	cout << "EnumNamedCounterImpl::Reset()" << endl;

	m_current = m_counters.beginList();
}

EnumNamedCounter_ptr EnumNamedCounterImpl::Clone()
{
	cout << "EnumNamedCounterImpl::Clone()" << endl;

	EnumNamedCounterImpl *pCopy = new EnumNamedCounterImpl(m_counters);
	
	pCopy->SetCurrent(m_current);

	return pCopy->_this();
}
