#ifndef ENUM_NAMED_COUNTER_IMPL_INCLUDED__
#define ENUM_NAMED_COUNTER_IMPL_INCLUDED__

#include "TRefCountedBase.h"

#include "NamedCounterFactory.h"

#include "refcount.h"

#include <vector>
#include <string>

struct EnumNamedCounterEvictorTraits
{
   static const size_t maxServants;
   static const size_t timeout;
};

class EnumNamedCounterImpl : 
   public TRefCounted<
      POA_EnumNamedCounter,
      EnumNamedCounter, 
      EnumNamedCounter_ptr,
      EnumNamedCounterEvictorTraits>
{
	public:
		
      EnumNamedCounterImpl(
         NamedCounterFactoryImpl::CounterContainer &counters);
      
      virtual ~EnumNamedCounterImpl();

		// EnumNamedCounter interface
		
		virtual CORBA::Long Next(
			CORBA::ULong maxCounters, 
			counterSeq& theCounters);

		virtual CORBA::Boolean Skip(
			CORBA::ULong numToSkip);

		virtual void Reset();
		
		virtual EnumNamedCounter_ptr Clone();

	private :

		void SetCurrent(NamedCounterFactoryImpl::CounterContainer::list_iterator &current);

      NamedCounterFactoryImpl::CounterContainer &m_counters;
      NamedCounterFactoryImpl::CounterContainer::list_iterator m_current;
};


#endif // ENUM_NAMED_COUNTER_IMPL_INCLUDED__