#ifndef NAMED_COUNTER__INCLUDED
#define NAMED_COUNTER__INCLUDED

#include "RefCount.h"

#include "TRefCountedBase.h"

#include <string>

struct NamedCounterEvictorTraits
{
   static const size_t maxServants;
   static const size_t timeout;
};

class NamedCounterImpl :
   public TRefCounted<
      POA_NamedCounter,
      NamedCounter, 
      NamedCounter_ptr,
      NamedCounterEvictorTraits>
{
   public :
      
      NamedCounterImpl(
         const std::string &name, 
         const CORBA::Long initialValue);

      // implement the interface

      virtual char* name();
      virtual CORBA::Long value();
      virtual void value(CORBA::Long);
      
   private :

      ~NamedCounterImpl();

      const std::string m_name;
      CORBA::Long m_value;
};

#endif NAMED_COUNTER_FACTORY__INCLUDED